<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/find_include_file_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr"> 1 </span>08/22/83  find_include_file_
<span id="L2" class="LineNr"> 2 </span>
<span id="L3" class="LineNr"> 3 </span>
<span id="L4" class="LineNr"> 4 </span>
<span id="L5" class="LineNr"> 5 </span>The primary entry point of the find_include_file_ subroutine searches
<span id="L6" class="LineNr"> 6 </span>for an include file on behalf of a translator.  If the include file is
<span id="L7" class="LineNr"> 7 </span>found, additional information about the segment found is returned in
<span id="L8" class="LineNr"> 8 </span>the parameters.  The &quot;translator&quot; search list is used to locate the
<span id="L9" class="LineNr"> 9 </span>include file.
<span id="L10" class="LineNr">10 </span>
<span id="L11" class="LineNr">11 </span>
<span id="L12" class="LineNr">12 </span>Entry points in find_include_file_:
<span id="L13" class="LineNr">13 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L14" class="LineNr">14 </span>
<span id="L15" class="LineNr">15 </span>
<span id="L16" class="LineNr">16 </span>:Entry:  initiate_count:  05/05/83 find_include_file_$initiate_count
<span id="L17" class="LineNr">17 </span>
<span id="L18" class="LineNr">18 </span>
<span id="L19" class="LineNr">19 </span>Function:  This entry point is the interface presented to translators.
<span id="L20" class="LineNr">20 </span>A translator calls this entry point to invoke a search for a single
<span id="L21" class="LineNr">21 </span>include file segment using the &quot;translator&quot; search list.  For more
<span id="L22" class="LineNr">22 </span>information about search lists, see the search facility commands, and
<span id="L23" class="LineNr">23 </span>in particular the add_search_paths command in the Commands manual.
<span id="L24" class="LineNr">24 </span>
<span id="L25" class="LineNr">25 </span>
<span id="L26" class="LineNr">26 </span>Syntax:
<span id="L27" class="LineNr">27 </span>declare find_include_file_$initiate_count entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L28" class="LineNr">28 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>24<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L29" class="LineNr">29 </span>call find_include_file_$initiate_count <span class="textRainbow_lv0_p0">(</span>translator<span class="textRainbow_lv0_o0">,</span> referencing_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L30" class="LineNr">30 </span>     file_name<span class="textRainbow_lv0_o0">,</span> bit_count<span class="textRainbow_lv0_o0">,</span> seg_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L31" class="LineNr">31 </span>
<span id="L32" class="LineNr">32 </span>
<span id="L33" class="LineNr">33 </span>Arguments:
<span id="L34" class="LineNr">34 </span>translator
<span id="L35" class="LineNr">35 </span>   is the name of the translator that is calling this procedure <span class="textRainbow_lv0_p0">(</span>e.g.<span class="textRainbow_lv0_o0">,</span>
<span id="L36" class="LineNr">36 </span>   pl1<span class="textRainbow_lv0_o0">,</span> alm<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L37" class="LineNr">37 </span>referencing_ptr
<span id="L38" class="LineNr">38 </span>   is a pointer into the segment <span class="textRainbow_lv0_p0">(</span>normally a pointer to the source
<span id="L39" class="LineNr">39 </span>   line<span class="textRainbow_lv0_p0">)</span> that caused the invocation of this instance of this procedure.
<span id="L40" class="LineNr">40 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L41" class="LineNr">41 </span>file_name
<span id="L42" class="LineNr">42 </span>   is the complete entryname of the include file this procedure is to
<span id="L43" class="LineNr">43 </span>   locate <span class="textRainbow_lv0_p0">(</span>e.g.<span class="textRainbow_lv0_o0">,</span> xxx.incl.pl1<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L44" class="LineNr">44 </span>bit_count
<span id="L45" class="LineNr">45 </span>   is the bit count as obtained from the storage system of the found
<span id="L46" class="LineNr">46 </span>   include file.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  If an include file is not found, this
<span id="L47" class="LineNr">47 </span>   parameter is set to 0.
<span id="L48" class="LineNr">48 </span>
<span id="L49" class="LineNr">49 </span>
<span id="L50" class="LineNr">50 </span>seg_ptr
<span id="L51" class="LineNr">51 </span>   is a pointer to the first character of the include file, if found;
<span id="L52" class="LineNr">52 </span>   if not found, this parameter is set to the null pointer value.
<span id="L53" class="LineNr">53 </span>   <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L54" class="LineNr">54 </span>code
<span id="L55" class="LineNr">55 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  The code can be:
<span id="L56" class="LineNr">56 </span>   0
<span id="L57" class="LineNr">57 </span>      the requested file was found normally.  All output parameters
<span id="L58" class="LineNr">58 </span>      have been set normally.
<span id="L59" class="LineNr">59 </span>   error_table_$zero_length_seg
<span id="L60" class="LineNr">60 </span>      the requested file was found, but the bit count was zero.  All
<span id="L61" class="LineNr">61 </span>      output parameters have been set normally.
<span id="L62" class="LineNr">62 </span>   error_table_$noentry
<span id="L63" class="LineNr">63 </span>      the requested file was not found in any of the search
<span id="L64" class="LineNr">64 </span>      directories.
<span id="L65" class="LineNr">65 </span>   other storage system error codes
<span id="L66" class="LineNr">66 </span>      the requested file was not found because of some error.
<span id="L67" class="LineNr">67 </span>
<span id="L68" class="LineNr">68 </span>
<span id="L69" class="LineNr">69 </span>Notes:
<span id="L70" class="LineNr">70 </span>If this procedure finds an include file by a link, the seg_ptr
<span id="L71" class="LineNr">71 </span>parameter correctly designates the actual location of the include file.
<span id="L72" class="LineNr">72 </span>It is possible, however, that the name of the actual include file is
<span id="L73" class="LineNr">73 </span>not the same as the file_name argument passed to this procedure.  It is
<span id="L74" class="LineNr">74 </span>the responsibility of the translator to determine if the file_name
<span id="L75" class="LineNr">75 </span>passed to this procedure is also on the include file actually found.
<span id="L76" class="LineNr">76 </span>It is also the responsibility of the translator to call the
<span id="L77" class="LineNr">77 </span>hcs_$terminate_noname entry point on the include file when processing
<span id="L78" class="LineNr">78 </span>is complete.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
